/**
  * @file    ADC/ADC_LOW_POWER/cs32f0xx_int.c 
  * @brief  Main Interrupt Service Routines. It provides template for
  *            all exceptions handler and  peripherals interrupt service routine.
  * @author  ChipSea MCU Group
  * @version V1.0.0
  * @date   2021.11.01         
  * @copyright CHIPSEA TECHNOLOGIES (SHENZHEN) CORP.
  * @note 
  * <h2><center>&copy; COPYRIGHT 2021 ChipSea</center></h2>
  *
  */
  
  
#include "cs32f0xx_int.h"


/** @addtogroup CS32F0xx_HAL_Examples
  * @{
  */

/** @addtogroup ADC_LOW_POWER
  * @{
  */


/** 
  * @fn void NMI_Handler(void)
  * @brief  This function handles NMI exception.
  * @param  None
  * @return None
  */
void NMI_Handler(void)
{
}

/**
  * @fn void HardFault_Handler(void)
  * @brief  This function handles Hard Fault exception.
  * @param  None
  * @return None
  */
void HardFault_Handler(void)
{
    /* Go to infinite loop when Hard Fault exception occurs */
    while (1)
    {
    }
}

/**
  * @fn void SVC_Handler(void)
  * @brief  This function handles SVCall exception.
  * @param  None
  * @return None
  */
void SVC_Handler(void)
{
}

/**
  * @fn void PendSV_Handler(void)
  * @brief  This function handles PendSVC exception.
  * @param  None
  * @return None
  */
void PendSV_Handler(void)
{
}

/**
  * @fn void SysTick_Handler(void)
  * @brief  This function handles SysTick Handler.
  * @param  None
  * @return None
  */
void SysTick_Handler(void)
{
}

/**
  * @fn void ADC1_IRQHandler(void)
  * @brief  This function handles ADC1  interrupts requests.
  * @param  None
  * @return None
  */
void ADC1_IRQHandler(void)
{
	if (__ADC_INTR_STATUS_GET(ADC1, DOVR))
    {
        cs_eval_led_on();
        __ADC_FLAG_CLEAR(ADC1, ADC_FLAG_DOVR);
    }
}

/**
  * @}
  */

/**
  * @}
  */

